define(
	'ApplicationSkeleton.Layout.Extension'
,   [
		'ApplicationSkeleton.Layout'
	,	'Header.View'
	,	'Footer.View'
	,	'Backbone.CompositeView'
	,	'underscore'
	,	'jQuery'	
	]
,   function (
		ApplicationSkeletonLayout
	,	HeaderView
	,	FooterView
	,	BackboneCompositeView
	,	_
	,	jQuery
	)
{
	'use strict';

		_.extend(ApplicationSkeletonLayout.prototype,
		{
			initialize: function (Application)
				{
					BackboneCompositeView.add(this);

					this.headerView = this.originalHeaderView = HeaderView;
					this.footerView = this.originalFooterView = FooterView;

					this.application = Application;
					this.windowWidth = jQuery(window).width();

					// @property {jQuery.Deferred} afterAppendViewPromise a promise that is resolve only if one view was shown in this layout
					this.afterAppendViewPromise = jQuery.Deferred();

					var self = this;

					this.once('afterAppendView', function ()
					{
						self.afterAppendViewPromise.resolve();
					});

					jQuery(window).on('resize', _.throttle(function ()
					{

						if (_.getDeviceType(self.windowWidth) === _.getDeviceType(jQuery(window).width()))
						{
							return;
						}

						_.resetViewportWidth();

						self.updateHeader();
						self.updateFooter();

						self.trigger('resize', self.currentView);

						self.updateLayoutSB && self.updateLayoutSB();

						self.windowWidth = jQuery(window).width();

					}, 1000));
				}
		});
});